#include <stdio.h>
#include <CUnit/Basic.h>
#include <stdbool.h>
#include "ListeChaineeDEntiers.h"
#include "FileDePrioriteDEntiers.h"

int init_suite_success(void) { 
  return 0; 
}

int clean_suite_success(void) { 
  return 0; 
}


/* mauvaise utilisation des tests unitaires (non boite noire) 
   mais c'est pour ne pas vous penaliser si votre fonction 
   pour enfiler ne fonctionne pas !!!!
*/
FDPDE_FileDePrioriteDEntiers file1() {
  FDPDE_FileDePrioriteDEntiers result;
  result.nb=1;
  result.premierASortir = LCDE_listeChainee();
  LCDE_ajouter(&(result.premierASortir),1);
  result.dernierASortir = result.premierASortir;   
  return result;
} 


FDPDE_FileDePrioriteDEntiers file1234() {
  FDPDE_FileDePrioriteDEntiers result;
  result.nb=4;
  result.premierASortir = LCDE_listeChainee();
  LCDE_ajouter(&(result.premierASortir),1);
  result.dernierASortir = result.premierASortir;
  LCDE_ajouter(&(result.premierASortir),2);
  LCDE_ajouter(&(result.premierASortir),3);
  LCDE_ajouter(&(result.premierASortir),4);    
  return result;
} 

FDPDE_FileDePrioriteDEntiers file123() {
  FDPDE_FileDePrioriteDEntiers result;
  result.nb=3;
  result.premierASortir = LCDE_listeChainee();
  LCDE_ajouter(&(result.premierASortir),1);
  result.dernierASortir = result.premierASortir;
  LCDE_ajouter(&(result.premierASortir),2);
  LCDE_ajouter(&(result.premierASortir),3);    
  return result;
}

FDPDE_FileDePrioriteDEntiers file234() {
  FDPDE_FileDePrioriteDEntiers result;
  result.nb=3;
  result.premierASortir = LCDE_listeChainee();
  LCDE_ajouter(&(result.premierASortir),2);
  result.dernierASortir = result.premierASortir;
  LCDE_ajouter(&(result.premierASortir),3);
  LCDE_ajouter(&(result.premierASortir),4);    
  return result;
}

FDPDE_FileDePrioriteDEntiers file134() {
  FDPDE_FileDePrioriteDEntiers result;
  result.nb=3;
  result.premierASortir = LCDE_listeChainee();
  LCDE_ajouter(&(result.premierASortir),1);
  result.dernierASortir = result.premierASortir;
  LCDE_ajouter(&(result.premierASortir),3);
  LCDE_ajouter(&(result.premierASortir),4);    
  return result;
}

FDPDE_FileDePrioriteDEntiers file1334() {
  FDPDE_FileDePrioriteDEntiers result;
  result.nb=4;
  result.premierASortir = LCDE_listeChainee();
  LCDE_ajouter(&(result.premierASortir),1);
  result.dernierASortir = result.premierASortir;
  LCDE_ajouter(&(result.premierASortir),3);
  LCDE_ajouter(&(result.premierASortir),3);  
  LCDE_ajouter(&(result.premierASortir),4);    
  return result;
} 

void test_file_vide_vide(void){
  CU_ASSERT_TRUE(FDPDE_estVide(FDPDE_fileDePrioriteDEntiers()));
}

void test_file_vide_non_vide(void){
  FDPDE_FileDePrioriteDEntiers f = file123();
  CU_ASSERT_FALSE(FDPDE_estVide(f));
  FDPDE_vider(&f);
}

void test_longueur_vide(void){
  CU_ASSERT_TRUE(FDPDE_longueur(FDPDE_fileDePrioriteDEntiers()) == 0);
}

void test_longueur_non_vide(void){
  FDPDE_FileDePrioriteDEntiers f = file1234();
  CU_ASSERT_TRUE(FDPDE_longueur(f) == 4);
  FDPDE_vider(&f);
}

void test_enfiler_dans_une_file_vide(void){
  FDPDE_FileDePrioriteDEntiers f1 = file1();
  FDPDE_FileDePrioriteDEntiers f2 = FDPDE_fileDePrioriteDEntiers();
  FDPDE_enfiler(&f2,1);
  CU_ASSERT_TRUE(FDPDE_egale(f1,f2));
  FDPDE_vider(&f1);
  FDPDE_vider(&f2); 
}

void test_enfiler_le_plus_grand(void){
  FDPDE_FileDePrioriteDEntiers f1 = file1234();
  FDPDE_FileDePrioriteDEntiers f2 = file123();
  FDPDE_enfiler(&f2,4);
  CU_ASSERT_TRUE(FDPDE_egale(f1,f2));
  FDPDE_vider(&f1);
  FDPDE_vider(&f2); 
}

void test_enfiler_le_plus_petit(void){
  FDPDE_FileDePrioriteDEntiers f1 = file1234();
  FDPDE_FileDePrioriteDEntiers f2 = file234();
  FDPDE_enfiler(&f2,1);
  CU_ASSERT_TRUE(FDPDE_egale(f1,f2));
  FDPDE_vider(&f1);
  FDPDE_vider(&f2); 
}

void test_enfiler_une_valeur_intermediaire(void){
  FDPDE_FileDePrioriteDEntiers f1 = file1234();
  FDPDE_FileDePrioriteDEntiers f2 = file134();
  FDPDE_enfiler(&f2,2);
  CU_ASSERT_TRUE(FDPDE_egale(f1,f2));
  FDPDE_vider(&f1);
  FDPDE_vider(&f2); 
}

void test_enfiler_deux_fois_meme_valeur(void){
  FDPDE_FileDePrioriteDEntiers f1 = file1334();
  FDPDE_FileDePrioriteDEntiers f2 = file134();
  FDPDE_enfiler(&f2,3);
  CU_ASSERT_TRUE(FDPDE_egale(f1,f2));
  FDPDE_vider(&f1);
  FDPDE_vider(&f2); 
}

void test_enfiler_longueur_augmente_bien(void){
  FDPDE_FileDePrioriteDEntiers f = file1234();
  int lAvant = FDPDE_longueur(f);
  FDPDE_enfiler(&f,5);
  CU_ASSERT_TRUE(FDPDE_longueur(f)==lAvant+1);
  FDPDE_vider(&f);
}

void test_obtenir_element(void){
  FDPDE_FileDePrioriteDEntiers f = file1234();
  CU_ASSERT_TRUE(FDPDE_obtenirElement(f)==4);
  FDPDE_vider(&f);
}

void test_obtenir_ieme_element_premier(void){
  FDPDE_FileDePrioriteDEntiers f = file1234();
  CU_ASSERT_TRUE(FDPDE_obtenirIemeElement(f,1)==4);
  FDPDE_vider(&f);
}

void test_obtenir_ieme_element_dernier(void){
  FDPDE_FileDePrioriteDEntiers f = file1234();
  CU_ASSERT_TRUE(FDPDE_obtenirIemeElement(f,4)==1);
  FDPDE_vider(&f);
}

void test_obtenir_ieme_element_3eme(void){
  FDPDE_FileDePrioriteDEntiers f = file1234();
  CU_ASSERT_TRUE(FDPDE_obtenirIemeElement(f,3)==2);
  FDPDE_vider(&f);
}

void test_defiler_file_a_un_seul_element(void){
  FDPDE_FileDePrioriteDEntiers f = file1();

  FDPDE_defiler(&f);
  CU_ASSERT_TRUE(FDPDE_egale(f,FDPDE_fileDePrioriteDEntiers()));
  FDPDE_vider(&f);
}


void test_defiler_general(void){
  FDPDE_FileDePrioriteDEntiers f1 = file1234();
  FDPDE_FileDePrioriteDEntiers f2 = file123();
  FDPDE_defiler(&f2);
  CU_ASSERT_TRUE(FDPDE_egale(f1,f2));
  FDPDE_vider(&f1);
  FDPDE_vider(&f2); 
}

int main(int argc, char** argv){
  CU_pSuite pSuite = NULL;

  /* initialisation du registre de tests */
  if (CUE_SUCCESS != CU_initialize_registry())
    return CU_get_error();

  /* ajout d'une suite de test */
  pSuite = CU_add_suite("Test File de priorite d'entiers - FDPDE (boite noire)", init_suite_success, clean_suite_success);
  if (NULL == pSuite) {
    CU_cleanup_registry();
    return CU_get_error();
  }

  /* Ajout des tests à la suite de tests boite noire */
  if ((NULL == CU_add_test(pSuite, "file vide est bien vide", test_file_vide_vide))
      || (NULL == CU_add_test(pSuite, "file non vide est bien non vide", test_file_vide_non_vide))
      || (NULL == CU_add_test(pSuite, "longueur d'une file vide", test_longueur_vide))
      || (NULL == CU_add_test(pSuite, "longueur (cas general)", test_longueur_non_vide))
      || (NULL == CU_add_test(pSuite, "enfiler dans une file vide", test_enfiler_dans_une_file_vide))
      || (NULL == CU_add_test(pSuite, "enfiler le plus grand", test_enfiler_le_plus_grand))
      || (NULL == CU_add_test(pSuite, "enfiler le plus petit", test_enfiler_le_plus_petit))
      || (NULL == CU_add_test(pSuite, "enfiler (cas general)", test_enfiler_une_valeur_intermediaire))
      || (NULL == CU_add_test(pSuite, "enfiler deux fois meme valeur", test_enfiler_deux_fois_meme_valeur))
      || (NULL == CU_add_test(pSuite, "enfiler longueur augmente bien", test_enfiler_longueur_augmente_bien))
      || (NULL == CU_add_test(pSuite, "obtenir element", test_obtenir_element))
      || (NULL == CU_add_test(pSuite, "obtenir ieme element (premier)", test_obtenir_ieme_element_premier))
      || (NULL == CU_add_test(pSuite, "obtenir ieme element (dernier)", test_obtenir_ieme_element_dernier))
      || (NULL == CU_add_test(pSuite, "obtenir ieme element (cas general)", test_obtenir_ieme_element_3eme)) 
      || (NULL == CU_add_test(pSuite, "defiler file d'un seul element", test_defiler_file_a_un_seul_element))
      || (NULL == CU_add_test(pSuite, "defiler (cas general)", test_defiler_file_a_un_seul_element))  
      )
    {
      CU_cleanup_registry();
      return CU_get_error();
    }

  /* Lancement des tests */
  CU_basic_set_mode(CU_BRM_VERBOSE);
  CU_basic_run_tests();
  printf("\n");
  CU_basic_show_failures(CU_get_failure_list());
  printf("\n\n");

  /* Nettoyage du registre */
  CU_cleanup_registry();
  return CU_get_error();
}
